libzypp: zyppng::sat::Capabilities Class Reference

libzypp 17.38.14

zyppng::sat::Capabilities Class Reference

Container of Capability (currently read only). More...

`#include <zypp/ng/sat/capabilities.h>`

## Classes
class | const_iterator
| Capabilities iterator. More...

## Public Types
enum | Mode { SKIP_TO_INTERNAL }
typedef Capability | value_type
typedef unsigned | size_type

## Public Member Functions
| Capabilities ()
| Default ctor.
| Capabilities (const sat::detail::IdType *base_r)
| Ctor from Id pointer (friend Solvable).
| Capabilities (const sat::detail::IdType *base_r, sat::detail::IdType skip_r)
| Ctor from Id pointer (friend Solvable).
bool | empty () const
| Whether the container is empty.
size_type | size () const
| Number of capabilities inside.
const_iterator | begin () const
| Iterator pointing to the first Capability.
const_iterator | end () const
| Iterator pointing behind the last Capability.
bool | contains (const Capability &lhs) const
| Return whether the set contains lhs (the Id).
bool | matches (const Capability &lhs) const
| Return whether lhs matches at least one capability in set.
Capability | findFirstMatch (const Capability &lhs) const
| Return the first matching Capability in set or Capability::Null.

## Private Attributes
const sat::detail::IdType * | _begin

## Detailed Description

Container of Capability (currently read only).

Note
  libsolv dependency lists may include internal ids which must be skipped on iteration or size calculation (

See also
  detail::isDepMarkerId).

Definition at line 32 of file capabilities.h.

## Member Typedef Documentation

## ◆ value_type

typedef Capability zyppng::sat::Capabilities::value_type

Definition at line 35 of file capabilities.h.

## ◆ size_type

typedef unsigned zyppng::sat::Capabilities::size_type

Definition at line 36 of file capabilities.h.

## Member Enumeration Documentation

## ◆ Mode

enum zyppng::sat::Capabilities::Mode

Enumerator
SKIP_TO_INTERNAL |

Definition at line 38 of file capabilities.h.

## Constructor & Destructor Documentation

## ◆ Capabilities() [1/3]

zyppng::sat::Capabilities::Capabilities | ( |  | ) |
| inline

Default ctor.

Definition at line 42 of file capabilities.h.

## ◆ Capabilities() [2/3]

zyppng::sat::Capabilities::Capabilities | ( | const sat::detail::IdType * | base_r | ) |
| inlineexplicit

Ctor from Id pointer (friend Solvable).

Definition at line 48 of file capabilities.h.

## ◆ Capabilities() [3/3]

zyppng::sat::Capabilities::Capabilities | ( | const sat::detail::IdType * | base_r,
|  | sat::detail::IdType | skip_r )

Ctor from Id pointer (friend Solvable).

Jump behind skip_r (e.g. behind prereqMarker).

Definition at line 22 of file capabilities.cc.

## Member Function Documentation

## ◆ empty()

bool zyppng::sat::Capabilities::empty | ( |  | ) | const
| inline

Whether the container is empty.

Definition at line 59 of file capabilities.h.

## ◆ size()

Capabilities::size_type zyppng::sat::Capabilities::size | ( |  | ) | const

Number of capabilities inside.

Definition at line 44 of file capabilities.cc.

## ◆ begin()

Capabilities::const_iterator zyppng::sat::Capabilities::begin | ( |  | ) | const
| inline

Iterator pointing to the first Capability.

Definition at line 179 of file capabilities.h.

## ◆ end()

Capabilities::const_iterator zyppng::sat::Capabilities::end | ( |  | ) | const
| inline

Iterator pointing behind the last Capability.

Definition at line 182 of file capabilities.h.

## ◆ contains()

bool zyppng::sat::Capabilities::contains | ( | const Capability & | lhs | ) | const
| inline

Return whether the set contains lhs (the Id).

Definition at line 185 of file capabilities.h.

## ◆ matches()

bool zyppng::sat::Capabilities::matches | ( | const Capability & | lhs | ) | const
| inline

Return whether lhs matches at least one capability in set.

Definition at line 193 of file capabilities.h.

## ◆ findFirstMatch()

Capability zyppng::sat::Capabilities::findFirstMatch | ( | const Capability & | lhs | ) | const
| inline

Return the first matching Capability in set or Capability::Null.

Definition at line 201 of file capabilities.h.

## Member Data Documentation

## ◆ _begin

const sat::detail::IdType* zyppng::sat::Capabilities::_begin
| private

Definition at line 85 of file capabilities.h.

The documentation for this class was generated from the following files:

- zypp/ng/sat/capabilities.h
- zypp/ng/sat/capabilities.cc